package heap;

import java.util.Comparator;
import java.util.PriorityQueue;

/**
 * 题目： 215. 数组中的第K个最大元素 (floodFill)
 * 描述：给定整数数组 nums 和整数 k，请返回数组中第 k 个最大的元素。
 * 请注意，你需要找的是数组排序后的第 k 个最大的元素，而不是第 k 个不同的元素。
 * 你必须设计并实现时间复杂度为 O(n) 的算法解决此问题。

 * 示例 1：
 输入: [3,2,1,5,6,4], k = 2
 输出: 5

 * 链接：https://leetcode.cn/problems/kth-largest-element-in-an-array/
 */
public class FindKthLargest {
    //完全填满堆再删除元素  最大堆
    public int findKthLargest1(int[] nums, int k) {
        PriorityQueue<Integer>maxheap=new PriorityQueue<>(Comparator.reverseOrder());
        for (int num : nums) {
            maxheap.add(num);
        }
        for (int i = 0; i < k-1; i++) {
            maxheap.poll();
        }
        return maxheap.peek();
    }
    //使用最小堆来存储前 k 个最大的元素。堆顶元素是 k 个最大元素中的最小值。这样，堆的大小始终保持为 k。当堆的大小大于 k 时，弹出堆顶元素。最终堆顶元素就是第 k 大的元素。不需要完全填满堆再删除元素：
    public int findKthLargest(int[] nums, int k) {
        // 使用最小堆
        PriorityQueue<Integer> minHeap = new PriorityQueue<>();

        // 遍历数组
        for (int num : nums) {
            // 如果堆的大小小于 k，直接加入元素
            if (minHeap.size() < k) {
                minHeap.add(num);
            } else if (num > minHeap.peek()) {
                // 如果堆的大小已达到 k，且当前元素大于堆顶元素，则替换堆顶
                minHeap.poll();
                minHeap.add(num);
            }
        }

        // 返回堆顶元素，即为第 k 大的元素
        return minHeap.peek();
    }
}
